#version 120

/*
!! DO NOT REMOVE !!
This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !!
*/

//ADJUSTABLE VARIABLES//

//#define WorldTimeAnimation
#define AnimationSpeed 1.0								//Set shader's speed. [0.1 0.25 0.5 0.75 1.0 2.0 3.0 4.0]

//ADJUSTABLE VARIABLES//

varying vec4 color;
varying vec2 texcoord;
varying vec2 lmcoord;
varying vec3 normal;

uniform int worldTime;
uniform float frameTimeCounter;

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

#ifdef WorldTimeAnimation
float frametime = worldTime/20.0*AnimationSpeed;
#else
float frametime = frameTimeCounter*AnimationSpeed;
#endif
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////

void main() {
	
	texcoord = (gl_MultiTexCoord0).xy;
	lmcoord = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	
	vec4 position = gl_ModelViewMatrix * gl_Vertex;
	
	position.y += sin(frametime)*0.01;
	position.z -= cos(frametime)*0.005;

	gl_Position = gl_ProjectionMatrix * position;
	
	color = gl_Color;
	
	normal = normalize(gl_NormalMatrix * gl_Normal);
	
}