#version 120

/*
!! DO NOT REMOVE !!
This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !!
*/

//ADJUSTABLE VARIABLES//

//#define WorldTimeAnimation
#define AnimationSpeed 1.0								//Set shader's speed. [0.1 0.25 0.5 0.75 1.0 2.0 3.0 4.0]

//ADJUSTABLE VARIABLES//

varying vec4 color;
varying vec4 texcoord;

uniform int worldTime;
uniform float frameTimeCounter;

uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////

#ifdef WorldTimeAnimation
float frametime = worldTime/20.0*AnimationSpeed;
#else
float frametime = frameTimeCounter*AnimationSpeed;
#endif

void main() {
	vec4 position = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
	
	position.x += position.y*0.05*cos(sin(frametime*0.25)*5+frametime*0.25*cos((position.z-frametime)*0.001));
	position.z += position.y*0.05*sin(cos(frametime*0.25)*5+frametime*0.25*sin((position.x-frametime)*0.001));
	
	gl_Position = gl_ProjectionMatrix * gbufferModelView * position;
	
	color = gl_Color;
	
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
}